﻿### CINEMA

### Develop/debug on Linux.

I. Установить WMWare Player: https://www.vmware.com/products/workstation-player/workstation-player-evaluation.html

II. Установить Ubuntu в WMWare: https://ubuntu.com/download/desktop

III. В Ubuntu установить Double Commander: https://github.com/doublecmd/doublecmd/releases

IV. Компиляция и отладка под Linux.

  IV.I Delphi
    1. Скопировать из поставки делфи LinuxPAServer22.0.tar.gz, рядом положить PAServer-22.0.sh и 
       запустить его в консоли, предварительно встав на этот каталог (можно из Double Commander 
       встав на скрипт просто нажать Shift+Enter).
    2. Запустить в консоли PAServer, который появится в подкаталоге PAServer/22 после предыдущего пункта, без ввода пароля.
    3. IDE Delphi/Tools/GetIt package manager/: в поиске указать linux, выбрать FMXLinux, жмакнуть Install. 
    4. Из Windows в IDE создай SDK.
    5. В Tagert platforms добавь Linux64.

  IV.I Lazarus+FPC
  
V. В случае возникновения ошибки "Exception class Stop (17)" выставить опцию: 
  "Tools/Options/Debugger/Embarcadero Debuggers/Native OS Exceptions: 64-bit Linux Exceptions and Signals/Stopped (signal) (SIGSTOP) ($11)" в "Run handled"

VI. Если линкер не может собрать, значит в SDK нехватает библиотек. Для устранения гуглить имя библиотеки выдаваемое 
  в ошибке линкером, имя следует в сообщении после ключа -l<имя>, например для -lgcc требует библиотеку gcc, установка: sudo apt install gcc. 
  После установки требуемой библиотеки в Linux, в IDE необходимо перезагрузить SDK:
  Tools/Options/Deployment/SDK Manager/<Ваш SDK>/Update Local File Cache. 
  В вопросе-диалоге о замене файлов нажать No all (как правило).
  
VII. Проверить наличие пакетов, например, на сетевом интерфейсе ens33 на порту 33456: 
     sudo tcpdump -c 4 -l -n -i ens33 'udp and port 33456'

VIII. Работа с Oracle. 

  1) Установка из пакета.
    1.1. Скачать последнего клиента (последний клиент не требует регистрации, может понадобится VPN): 
	   https://www.oracle.com/database/technologies/instant-client/linux-x86-64-downloads.html
    1.2. Обратить внимание на зависимость указанную на сайте в заголовке к версии, доустановить их если необходимо.
    1.3. Доустановить: sudo apt-get install libaio1
    1.4. Установить инструмент alien для конвертации пакета установки *.rpm в пакеты *.deb
    1.5. Сконвертировать с помощью alien скаченный клиент в пакете *.rpm в пакет *.deb
    1.6. Установить пакет клиента с помощью sudo dpkg -i <имя пакета>
    1.7. Проверить доступность клиента: if LoadLibrary('libclntsh.so') = 0 then ShowMessage('WTF?');
  
  2) Установка из архива
    2.1. Выполнить в распакованном каталоге с клиентом (21.1 поправить на соответствующую версию, так же обратить внимание не появились ли новые симлинки и проделать аналогичное с ними):
       rm libocci_gcc53.so
       rm libocci.so
       rm libclntsh.so
       rm libclntshcore.so
       ln -s libocci_gcc53.so.21.1 libocci_gcc53.so
       ln -s libocci.so.21.1 libocci.so
       ln -s libclntsh.so.21.1 libclntsh.so
       ln -s libclntshcore.so.21.1 libclntshcore.so
    2.2. В каталог /etc/ld.so.conf.d/ добавить файл с расширением .conf в котором указать путь к папке с клиентом.
    2.3. Можно перелогиниться или выполнить sudo ldconfig что бы заставить систему подгрузить добавленный путь в /etc/ld.so.conf.d/ , но надёжнее перегрузить.
    2.4. Доустановить: sudo apt-get install libaio1
    
IX. Прочее.
  1. Некоторые полезные команды Linux: 
    - printenv - вывести все переменные окружения
    - sudo ldconfig - перегрузка каталогов поиска библиотек
    - ldd <файл> - вывести зависимости
    - nm <файл> - список экспорта
    - echo - вывести в консоль что либо, например echo $LD_LIBRARY_PATH выведет значение переменной окружения LD_LIBRARY_PATH
    - strace <исполняемый файл> - запуск программы с логированием системных вызовов (с сохранением вывода в файл: strace -o fileName.txt <исполняемый файл>)
    
  2. Правильная установка переменной LD_LIBRARY_PATH в файле /home/user/.bashrc:
    if ["$LD_LIBRARY_PATH" = ""]; then
      export LD_LIBRARY_PATH=/home/user/Downloads/oracle/lib/
    else
      export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/user/Downloads/oracle/lib/
    fi

