﻿#pragma once

using namespace std;

#include <Unknwn.h>
#include <atomic>

class CinemaPlugin: public ICinemaPlugin
{
private:
	std::atomic<ULONG> Counter;
public:
	virtual ~CinemaPlugin();
	// Inherited via IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef(void);
	virtual ULONG STDMETHODCALLTYPE Release(void);

	virtual void* STDMETHODCALLTYPE CreateDataStreamProcessor(TDataStream AInputDataStream, int ANumberInput);
	virtual void STDMETHODCALLTYPE ProcessDataStream(void* AProcessor, byte* AData, __int64 ASize);
	virtual void STDMETHODCALLTYPE DestroyDataStreamProcessor(void* AProcessor);
	/// <summary> обновить графику плагина (таблицы и прочее что в будущем ещё может понадобится вывести) </summary>
	virtual void STDMETHODCALLTYPE RedrawView();
};

