﻿#ifndef CINEMATYPESH
#define CINEMATYPESH

#if INTPTR_MAX == INT64_MAX
// 64-bit
typedef  __int64 NativeInt;
#elif INTPTR_MAX == INT32_MAX
typedef  __int32 NativeInt;
#else
#error Unknown pointer size or missing size macros!
#endif

  // Data.DB.TFieldType
enum TAttributeType {
    atRaw = 0, atString = 1, atSmallint = 2, atInteger = 3, atWord = 4, // 0..4
    atBoolean = 5, atFloat = 6, atCurrency = 7, atBCD = 8, atDate = 9, atTime = 10, atDateTime = 11, // 5..11
    atBytes = 12, atVarBytes = 13, atAutoInc = 14, atBlob = 15, atMemo = 16, atGraphic = 17, atFmtMemo = 18, // 12..18
    atParadoxOle = 19, atDBaseOle = 20, atTypedBinary = 21, atCursor = 22, atFixedChar = 23, atWideString = 24, // 19..24
    atLargeint = 25, atADT = 26, atArray = 27, atReference = 28, atDataSet = 29, atOraBlob = 30, atOraClob = 31, // 25..31
    atVariant = 32, atInterface = 33, atIDispatch = 34, atGuid = 35, atTimeStamp = 36, atFMTBcd = 37, // 32..37
    atFixedWideChar = 38, atWideMemo = 39, atOraTimeStamp = 40, atOraInterval = 41, // 38..41
    atLongWord = 42, atShortint = 43, atByte = 44, atExtended = 45, atConnection = 46, atParams = 47, atStream = 48, //42..48
    atTimeStampOffset = 49, atObject = 50, atSingle = 51
};

typedef int TMessageType;
typedef TAttributeType TCinemaFieldType;

#define MESSAGE_INFO 0;
#define MESSAGE_WARN 1;
#define MESSAGE_ERROR 2;

#define HEALTH_STATE_OK 100; // %
#define HEALTH_STATE_DEAD 0; // %

#if defined(_WIN64) || defined(_WIN32)
    #define ContrPathDelim "\\";
#else
    #define ContrPathDelim "/";
#endif

#endif