﻿unit Cinema.Dialog.CreateConnection;

interface

uses
  {$ifdef FPC}
    SysUtils
  , Types
  , System.UITypes
  , Classes
  , Variants
  , Forms
  , Controls
  , StdCtrls
  , Graphics
  , Buttons
  , ActnList
  , ExtCtrls
  {$else}
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls, FMX.Edit, FMX.Controls.Presentation, System.Actions, FMX.ActnList, System.ImageList,
  FMX.ImgList, FMX.ListBox
  {$endif}
  ;

type
  TfrmCreateConnection = class(TForm)
    ActionList: TActionList;
    acnAccept: TAction;
    acnCancel: TAction;
    Panel1: TPanel;
    edIntegerValue: TEdit;
    Button1: TButton;
    Button2: TButton;
    ImageList: TImageList;
    cbInputs: TComboBox;
    lblNumberOutput: TLabel;
    lblInput: TLabel;
    procedure acnAcceptExecute(Sender: TObject);
    procedure acnCancelExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure SetShowInputNumber(const Value: boolean);
    procedure SetCountInputs(const Value: Integer);
    { Private declarations }
  public
    { Public declarations }
    property ShowInputNumber: boolean write SetShowInputNumber;
    property CountInputs: Integer write SetCountInputs;
  end;

var
  frmCreateConnection: TfrmCreateConnection;

implementation

uses
  Math;

{$ifdef FPC}
  {$R *.lfm}
{$else}
  {$R *.fmx}
{$endif}

procedure TfrmCreateConnection.acnAcceptExecute(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TfrmCreateConnection.acnCancelExecute(Sender: TObject);
begin
  Close;
  ModalResult := mrCancel;
end;

procedure TfrmCreateConnection.FormShow(Sender: TObject);
begin
  edIntegerValue.SetFocus;
  edIntegerValue.SelectAll;

  {$ifdef fpc}
  Left := max(0, Mouse.CursorPos.X - Width div 2);
  Top := max(0, Mouse.CursorPos.Y - Height div 2);
  {$else}
  Left := max(0, Screen.MousePos.Round.X - Width div 2);
  Top := max(0, Screen.MousePos.Round.Y - Height div 2);
  {$endif}
end;

procedure TfrmCreateConnection.SetCountInputs(const Value: Integer);
var
  i: Integer;
begin
  cbInputs.Items.Clear;
  if Value < 2 then
  begin
    cbInputs.Visible := false;
    lblInput.Visible := false;
    Height := 160;
  end else
  begin
    cbInputs.Visible := true;
    lblInput.Visible := true;
    Height := 205;
  end;

  for i := 0 to Value - 1 do
    cbInputs.Items.Add('Data');

  cbInputs.ItemIndex := 0;

end;

procedure TfrmCreateConnection.SetShowInputNumber(const Value: boolean);
begin
  //121
end;

end.
