﻿unit Cinema.DialogString;

interface

uses
  {$ifdef FPC}
    SysUtils
  , System.UITypes
  , Classes
  , Variants
  , Forms
  , Controls
  , StdCtrls
  , Graphics
  , Buttons
  , ActnList
  , ExtCtrls
  {$else}
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls, FMX.Edit, FMX.Controls.Presentation, System.Actions, FMX.ActnList, System.ImageList,
  FMX.ImgList
  {$endif}
  ;

type
  TfrmStringValue = class(TForm)
    ActionList: TActionList;
    acnAccept: TAction;
    acnCancel: TAction;
    Panel1: TPanel;
    edStringValue: TEdit;
    Button1: TButton;
    Button2: TButton;
    ImageList: TImageList;
    procedure acnAcceptExecute(Sender: TObject);
    procedure acnCancelExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmStringValue: TfrmStringValue;

implementation

uses
  Math
  ;

{$ifdef FPC}
  {$R *.lfm}
{$else}
  {$R *.fmx}
{$endif}

procedure TfrmStringValue.acnAcceptExecute(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TfrmStringValue.acnCancelExecute(Sender: TObject);
begin
  Close;
  ModalResult := mrCancel;
end;

procedure TfrmStringValue.FormShow(Sender: TObject);
begin
  edStringValue.SetFocus;
  edStringValue.SelectAll;

  {$ifdef fpc}
  Left := max(0, Mouse.CursorPos.X - Width div 2);
  Top := max(0, Mouse.CursorPos.Y - Height div 2);
  {$else}
  Left := max(0, Screen.MousePos.Round.X - Width div 2);
  Top := max(0, Screen.MousePos.Round.Y - Height div 2);
  {$endif}
end;

end.
